%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS $Id: arith.ql,v 1.8 1999/10/25 18:48:32 itp Exp $


?- op(930,xfx,evals).
?- op(520,xfx,is_lt).
?- op(520,xfx,is_le).

/*
**  Decision procedures for integer arithmetic not involving variables
*/

X evals Y :- once(( var(Y) ; integer(Y) )), !, X = Y.
X evals Y :- '$evals'(Y, X).

'$evals'(succ(A),      X) :- !, '$evals'((A + 1), X).
'$evals'(pred(A),      X) :- !, '$evals'((A - 1), X).
'$evals'('-'(Y),       X) :- !, Y2 evals Y, '$minus1'(Y2, X).
'$evals'('+'(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$plus'(Y2, Z2, X).
'$evals'('*'(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$times'(Y2, Z2, X).
'$evals'('/'(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$divide'(Y2, Z2, X).
'$evals'('div'(Y, Z),  X) :- !, Y2 evals Y, Z2 evals Z, '$divide'(Y2, Z2, X).
'$evals'(mod(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$mod'(Y2, Z2, X).
'$evals'('**'(Y, Z),   X) :- !, Y2 evals Y, Z2 evals Z, '$power'(Y2, Z2, X).
'$evals'(bitand(Y, Z), X) :- !, Y2 evals Y, Z2 evals Z, '$bitwise_and'(Y2, Z2, X).
'$evals'(bitor(Y, Z),  X) :- !, Y2 evals Y, Z2 evals Z, '$bitwise_or'(Y2, Z2, X).
'$evals'('<<'(Y, Z),   X) :- !, Y2 evals Y, Z2 evals Z, '$shift_left'(Y2, Z2, X).
'$evals'('>>'(Y, Z),   X) :- !, Y2 evals Y, Z2 evals Z, '$shift_right'(Y2, Z2, X).

'$evals'(sgn(A),       X) :- !, A2 evals A, '$sgn'(A2, X).
'$evals'(abs(A),       X) :- !, A2 evals A, '$abs'(A2, X).
'$evals'(min(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$min'(Y2, Z2, X).
'$evals'(max(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$max'(Y2, Z2, X).

'$sgn'(A, X) :-
        integer(A),
        (   A < 0
            ->
                X = -1
            ;
            A = 0
            ->
                X = 0
            ; /* otherwise */
                X = 1
        ).

'$abs'(A, X) :-  integer(A), (A < 0 -> X evals -A; X = A).
'$min'(Y, Z, X) :- integer(Y), integer(Z), (Y =< Z -> X = Y; X = Z).
'$max'(Y, Z, X) :- integer(Y), integer(Z), (Y >= Z -> X = Y; X = Z).

M is_lt N :- M2 evals M, N2 evals N, '$less_than'(M2, N2).

M is_le N :- M is_lt N, !.
M is_le N :- M2 evals M, N2 evals N, M2 == N2.


