%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS $Id: startup.thy,v 1.5 1994/10/24 06:20:51 nickson Exp $

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This file builds a usable version of Ergo, starting from a minimal
%% version that has no preloaded tactics, plus an empty global.erg file.
%%
%% To use this file:
%%
%%    1. create an empty global.erg file.
%%    2. run a minimal version of Ergo with this file as its
%%       standard input, or alternatively, use the macro/1 command
%%       to execute this file.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Set up default path.
set_path('.').
set_path(lib(tactics)).
set_path(lib(thy)).

%% Set up the standard DBMS interface.
add_global_tactic_file(dbms).
setup_dbms_interface.   %% this will load abbrev.ql and operator.ql
add_global_tactic_file(show).
add_global_tactic_file(elves).
setup_elves.         %% this will load showwin.ql and focus.ql
%% NB set_default_prover(elves,1) will be done in ergo.thy.

%% Finally, start up the dbms interface for this session.
dbms_interface.
