%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%%
%%  Special commands that should only be needed by Ergo
%%  development personnel (eg. to analyse faults etc).
%%
%%  WARNING: For security, this file should *not* be added into global.erg
%%  files that are to be used by people who are not Ergo developers.
%%
%% CVS $Id: developer.ql,v 1.11 2001/06/04 01:24:10 itp Exp $


general command
  xyzzy
doc
  %% Don't advertise this command by linking it into a help tree.
  'For Ergo developers only.'
implementation
  break
mode
  xyzzy.

general command
  xyzzy(Goal)
doc
  %% Do not advertise this command by linking it into a help tree.
  'For Ergo developers only.'
mode
  xyzzy(+code).

xyzzy(Goal) :-
  ( call_predicate(Goal) ->
      msg(xyzzy, 1, [w(Goal)])
  ;
      msg(xyzzy, 1, ['(failed)'])
  ),
  nl.


general command
  debugon(Patt),
  debugoff(Patt)
doc
  %% Do not advertise this command by linking it into a help tree.
  'For Ergo developers only.',nl,
  'Enables/Disables debugging messages that match Patt.'
mode
  debugon(?term),
  debugoff(?term).

debugon(Patt) :- assert(dbg(Patt)).
debugoff(Patt) :- retractall(dbg(Patt)).


general command
  spy(Pred),
  nospy(Pred),
  nospyall
doc
  %% Do not advertise this command by linking it into a help tree.
  'For Ergo developers only.',nl,
  'Adds/Removes a Prolog spypoint on Pred.',nl,
  'Examples:  spy(fred).  spy(fred/3).'
mode
  spy(+term),
  nospy(?term),
  nospyall.

%% TO DO: The command spy/1 only really works when the code it is referring
%% to is not compiled but interpreted.

general command
  check_open_streams
mode
  check_open_streams.

check_open_streams :-
    check_open_streams(input),
    check_open_streams(output).

check_open_streams(Prop) :-
    stream_property(S, Prop),
    show_open_stream(S, Prop),
    fail.
check_open_streams(_).

general command
  close_excess_streams
mode
  close_excess_streams.

close_excess_streams :-
    close_excess_streams(input),
    close_excess_streams(output).

close_excess_streams(Prop) :-
    stream_property(S, Prop),
    \+ stream_property(S, alias(_)),
    show_open_stream(S, Prop),
    close(S),
    fail.
close_excess_streams(_).

show_open_stream(S, Prop) :-
    ( stream_property(S, alias(A)) ->
        true
    ; stream_property(S, file_name(A)) ->
        true
    ;
        A = '<no name>'
    ),
    writelist([w(S), tab, w(Prop), tab, w(A), nl]).
