%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: emacs_elves.ql,v 1.7 2000/11/15 06:29:49 itp Exp $
%%
%% Support for managing elves via the Emacs interface.

#include "../prover/lib/ergo.h"

general command
  emacs_edit_elves,
  emacs_edit_default_elves
doc
  'Edit the current or default elves list.'
mode
  emacs_edit_elves,
  emacs_edit_default_elves.

emacs_edit_elves :-
    emacs_edit_elves(load_current).
emacs_edit_elves :-
    handle_error(['Current elves list is valid only within a proof.']).

emacs_edit_default_elves :-
    emacs_edit_elves(load_default).

emacs_edit_elves(Kind) :-
    elf_parameters(Kind, ListParam, ActiveParam, HintsParam),
    !,
    get_parameter(ListParam, List),
    get_parameter(ActiveParam, Active),
    get_parameter(HintsParam, Hints),
    emacs_magic('EDITELVES'),
    emacs_edit_elves(List, Active, Hints),
    emacs_magic('NORMAL').
emacs_edit_elves(save_default) :-
    emacs_magic('SAVEELVES'),
    writelist(['default',nl]),
    emacs_magic('NORMAL').
emacs_edit_elves(save_current) :-
    emacs_magic('SAVEELVES'),
    writelist(['current',nl]),
    emacs_magic('NORMAL').

emacs_edit_elves(List, Active, Hints) :-
    query_ancestors(elf(Name, _Doc), Thy),
    elf_status(Thy, Name, List, Active, Hints, Category, Position),
    writelist([w(Category), ' ', w(Position), ' ', w(Thy), ' ', w(Name), nl]),
    fail.
emacs_edit_elves(_,_,_).

elf_status(Thy, Name, List, Active, Hints, Category, Position) :-
    PRE('elf_status', (integer(Active), integer(Hints))),
    concat_atom([Thy, :, Name], FullName),
    ( nth1(Position, List, FullName) ->
        true
    ;
        Position = 0
    ),
    ( Position>0, Position=<Active ->
        Category = active
    ; Position>0, Position=<Hints ->
        Category = hinted
    ; Position>0 ->
        Category = ignored
    ;
        Category = other
    ).

elf_parameters(load_default,
               default_elves_list, default_active_elves, emacs_auto_hints).
elf_parameters(load_current,
               elves_list, active_elves, emacs_auto_hints).
