%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%%
%% CVS $Id: modes_help.ql,v 1.5 2002/06/27 05:10:26 itp Exp $


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This file contains help documentation for mode declarations. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


modes_help doc
  'The modes documentation is based on the Qu-Prolog modes.',nl,
  'However, in addition to the Qu-Prolog meta-types, Ergo Prolog code may',nl,
  'use synonyms defined by the add_type/3 command',nl,
  '(eg. ',q(theory),', ',q(rulename),', ',q(writelist),' ', emph(etc),'.).',nl,
  'Use of these synonyms aids readability and may also help to hide',nl,
  'changes to the underlying representations of such data.',
  para,
  'To aid in documentation and to allow `type checking'' programs',nl,
  'to be run on Prolog source code, mode declarations for',nl,
  'every procedure should be given.',nl,
  'These mode declarations are included in the declaration, or comment,',nl,
  'that describes the procedure.',
  para,
  'Each mode declaration is of the form ',emph(mode),' followed',nl,
  'by the procedure name with mode/type arguments (described below)',nl,
  'and terminated with a `.''.',
  para,
  'The allowable modes follow the ISO Draft Prolog standard',nl,
  'and are summarised in the table below.',nl,
  begin(verb),
  'mode        description',nl,
  '---------   -----------',nl,
  '-termtype   A ',emph(var),' on call, at most termtype on success',nl,
  '+termtype   A ',emph(nonvar),' on call, at most termtype on success',nl,
  '?termtype   A ',emph(term),' on call, at most termtype on success',nl,
  '@termtype   A termtype on call, unchanged on success',nl,
  end(verb),
  'The allowable types for terms are classed as follows:',nl
header
  'Modes and Types'
extends
  concepts.


