%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: apart.thy,v 1.5 2001/07/03 22:01:03 itp Exp $

                                %%%%%%%%%%%%%%%
				%% Apartness %%
                                %%%%%%%%%%%%%%%

%% This theory defines an apartness relation.  If two objects are apart then
%% they are strongly not equal.  Such a relation is needed since in some
%% logics logical negation is not strong enough.

add_theory(apart).
include_theory(stdops, share).
include_theory(jprop_eq, all).
include_theory(cprop, all).
include_theory(p_list, all).


                                %%%%%%%%%%%%%%%
				%% Functions %%
                                %%%%%%%%%%%%%%%
 
declare apart(_,_).

add_operator(700, nonassoc, apart).

abbreviation '/='(A,B) ===
  A apart B.
 
add_operator(700, nonassoc, '/=').                                              

declare apart(_).

                                %%%%%%%%%%%%%%%
				%% Tactics   %%
                                %%%%%%%%%%%%%%%

require_tactic_file(apart).
                                 %%%%%%%%%%%%
				 %% Axioms %%
                                 %%%%%%%%%%%%

axiom not_apart_eq ===
  not (X apart Y) <=> X = Y.

axiom apart_or ===
  X apart Y => X apart Z or Y apart Z.

axiom mem_apart_list ===
    apart(L) => X apart Y
      provided
        delay_until(ground(L), apart_oracle(X, Y, L)).

%rule mem_apart_list ===
%  apart(L) => X apart Y
%    provided 
%     delay_until_closed_list(L, 
%                    ('p_list:as_list'(L, L1),
%                     member(X, L1),
%                     member(Y, L1), 
%                     '\\=='(X,Y))).
%

                                %%%%%%%%%%%%%%
				%% Theorems %%
                                %%%%%%%%%%%%%%

theorem not_apart ===
  not (X apart X).

% Intuitionistic?
theorem apart_sym ===
  X apart Y <=> Y apart X.

theorem apart_not_eq ===
  X apart Y => not X = Y.

theorem eq_stable ===
  not not X = Y => X = Y.

% Intuitionistic?
theorem apart_or_eq ===
  X apart Y or X = Y.

theorem eq_not_apart ===
  X = Y <=> not (X apart Y).

theorem open_apart_1_iff ===
    X = Y
  -----------
   (X apart Z) <=> (Y apart Z).

theorem open_apart_2_iff ===
    X = Y
  -----------
   (Z apart X) <=> (Z apart Y).


