%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: cpred.thy,v 1.5 2002/04/28 05:03:58 itp Exp $
%%
%% Classical Predicate Logic (untyped, without equality)
%% =====================================================

add_theory(cpred).
include_theory(stdops,share).
include_theory(ipred,all).
include_theory(cprop,all).

close_theory.


%% Simplification rules
%% ====================

theorem not_all_iff_ex_not(x:obvar) ===
    not (all x A) <=> (ex x (not A)).


%% Distribution rules
%% ==================

theorem ex_and_imp_ex_and_ex ===
    (ex x (A and B)) => (ex x A) and (ex x B).

theorem ex_or_iff_ex_or_ex ===
    (ex x (A or B)) <=> (ex x A) or (ex x B).

theorem all_imp_iff_ex_imp ===
    (all x (A => B)) <=> ((ex x A) => B)
    provided x not_free_in B.

theorem ex_imp_iff_imp_ex ===
    (ex x (A => B)) <=> (A => (ex x B))
    provided x not_free_in A.

theorem not_ex_iff_all_not(x:obvar) ===
    not (ex x A) <=> (all x (not A)).


%% Other rules
%% ===========

theorem weak_ex_elim ===
    (ex x A) and (A => B) => B
    provided x not_free_in A.




