%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: cpred_eq_t.thy,v 1.5 2000/10/11 05:48:17 itp Exp $
%%
%% Classical Predicate Calculus with Equality and Typed Quantifiers
%% ================================================================
%%

add_theory(cpred_eq_t).
include_theory(stdops,   share).
include_theory(cpred_eq, all).
include_theory(ipred_eq_t,  all).
close_theory.


%% Distribution rules
%% ==================

theorem not_all_t_iff_ex_t_not ===
    not (all x:T A) <=> (ex x:T (not A)) provided
    x not_free_in T.

theorem ex_t_and_imp_ex_t_and_ex_t ===
    (ex x:T (A and B)) => (ex x:T A) and (ex x:T B) provided
    x not_free_in T.

theorem ex_t_or_iff_ex_t_or_ex_t ===
    (ex x:T (A or B)) <=> (ex x:T A) or (ex x:T B) provided
    x not_free_in T.

theorem all_t_imp_iff_ex_t_imp ===
    (all x:T (A => B)) <=> ((ex x:T A) => B)
    provided x not_free_in B, x not_free_in T.

theorem ex_t_imp_iff_imp_ex_t ===
    (ex x:T (A => B)) => (A => (ex x:T B))
    provided x not_free_in A, x not_free_in T.

theorem not_ex_t_iff_all_t_not ===
    not (ex x:T A) <=> (all x:T (not A)) provided
    x not_free_in T.


