%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: if.thy,v 1.7 2002/08/23 01:23:38 itp Exp $


add_theory(if).
include_theory(stdops, share).
include_theory(jprop_eq, all).
include_theory(cprop, all).


 
                                %%%%%%%%%%%%%%%
                                %% Functions %%
                                %%%%%%%%%%%%%%%
declare if(_,_,_).
 
                                 %%%%%%%%%%%%
                                 %% Axioms %%
                                 %%%%%%%%%%%%
 
axiom if_true ===
  C => if(C, A, B) = A.
 
axiom if_false ===
  not C => if(C, A, B) = B.
 
                                %%%%%%%%%%%%%%
                                %% Theorems %%
                                %%%%%%%%%%%%%%
 
theorem if_cases ===
  if(C, A, B) = A or
  if(C, A, B) = B.       

%% Opening rules

theorem open_if_1_iff ===
    hyp +++ [not(B <=> C)] ---> A <=> D
    ------------------------------------
         if(A,B,C) <=> if(D,B,C).

theorem open_if_1_imp ===
    hyp +++ [not(B <=> C)] ---> A <=> D
    ------------------------------------
         if(A,B,C) => if(D,B,C).

theorem open_if_2_iff ===
    hyp +++ [A] ---> B <=> D
    ------------------------------------
         if(A,B,C) <=> if(A,D,C).      

theorem open_if_3_iff ===
    hyp +++ [not(A)] ---> C <=> D
    ------------------------------------
         if(A,B,C) <=> if(A,B,D).      

theorem open_if_1_eq ===
    hyp +++ [not(B = C)] ---> A <=> D
    ------------------------------------
         if(A,B,C) = if(D,B,C).

theorem open_if_2_eq ===
    hyp +++ [A] ---> B = D
    ------------------------------------
         if(A,B,C) = if(A,D,C).      

theorem open_if_3_eq ===
    hyp +++ [not(A)] ---> C = D
    ------------------------------------
         if(A,B,C) = if(A,B,D).      

theorem open_if_2_imp ===
    hyp +++ [A] ---> B => D
    ------------------------------------
         if(A,B,C) => if(A,D,C).      

theorem open_if_3_imp ===
    hyp +++ [not(A)] ---> C => D
    ------------------------------------
         if(A,B,C) => if(A,B,D).      

%% Simplification rules
theorem if_parallel ===
  if(A, B, B) = B.
 
theorem if_true1 ===
  if(true, A, B) = A.
 
theorem if_false1 ===
  if(false, A, B) = B.
 
%% Other rules
theorem true_imp_if ===
   P => if(P, true, false).    
 
theorem if_imp ===
   if(P, true, false) => P.
 
theorem if_true_false ===
   if(P, true, false) <=> P.
 
theorem back_thm ===
   (P => Q) => Q = if(P, true, Q).
 
theorem back_thm1 ===
   (P => Q = R) => Q = if(P, R, Q).
 
theorem back_thm2 ===
   (P => Q = R) => R = if(P, Q, R).
 
theorem back_thm3 ===
   (P => (Q <=> R)) => (R <=> if(P, Q, R)).
 
theorem back_thm4 ===
   (P => (Q <=> R)) => (Q <=> if(P, R, Q)).    

theorem if_imp_or ===
  if(P, A, B) => (A or B).
 
% Classical?
theorem if_not ===
   if(P, false, true) <=> not P.
 
% Classical?
theorem ifif ===
   if(if(P, false, true), false, true) <=> P.   


theorem if_eq ===
    if(A,B,C) = D <=> (A => B = D) and (not A => C = D).

theorem swap_ifs ===
    not(A and B) => if(A, TA, if(B, TB, EB)) = if(B, TB, if(A, TA, EB)).

%%
%% Support for Window Inference - loads
%% if specific information.
%%

require_tactic_file(wi_support,if).

