%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: jpred_eq_t.thy,v 1.12 2002/07/19 01:18:27 itp Exp $
%%
%% Classical Predicate Calculus with Equality
%% ==========================================
%%

add_theory(jpred_eq_t).
include_theory(stdops,  share).
include_theory(types,   all).
close_theory.

%% Define typed quantifiers
%% ========================

define all [x:Type] Body ===
  all x (x:Type => Body).

define ex [x:Type] Body ===
  ex x (x:Type and Body).

define ex_one [x:Type] Body ===
  ex_one x (x:Type and Body).  

theorem open_all_1_fol(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <= A
  ------------------
  (all x:T B) <= (all x:T A)
     provided x not_free_in T.
 
theorem open_all_1_imp(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B => A
  ------------------
  (all x:T B) => (all x:T A)
     provided x not_free_in T.
 
theorem open_all_1_iff(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <=> A
  -------------------
  (all x:T B) <=> (all x:T A)
     provided x not_free_in T.  

theorem open_ex_1_fol(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <= A
  ----------------
  (ex x:T B) <= (ex x:T A)
     provided x not_free_in T.
 
theorem open_ex_1_imp(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B => A
  ----------------
  (ex x:T B) => (ex x:T A)
     provided x not_free_in T.
 
theorem open_ex_1_iff(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <=> A
  -----------------
  (ex x:T B) <=> (ex x:T A)
     provided x not_free_in T.     
	
theorem open_ex_one_1_fol(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <=> A
  ----------------
  (ex_one x:T B) <= (ex_one x:T A)
     provided x not_free_in T.
 
theorem open_ex_one_1_imp(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <=> A
  ----------------
  (ex_one x:T B) => (ex_one x:T A)
     provided x not_free_in T.
 
theorem open_ex_one_1_iff(x:obvar) ===
  hyp ??? nfi(x) +++ [x:T] ---> B <=> A
  -----------------
  (ex_one x:T B) <=> (ex_one x:T A)
     provided x not_free_in T.     
	
%% Type opening rules

theorem open_all_t_1_fol ===
  hyp ??? nfi(x) ---> A = B
  ------------------
  (all x:A X) <= (all x:B X).
 
theorem open_all_t_1_imp ===
  hyp ??? nfi(x) ---> A = B
  ------------------
  (all x:A X) => (all x:B X).
 
theorem open_all_t_1_iff ===
  hyp ??? nfi(x) ---> A = B
  -------------------
  (all x:A X) <=> (all x:B X).

theorem open_ex_t_1_fol ===
  hyp ??? nfi(x) ---> A = B
  ----------------
  (ex x:A X) <= (ex x:B X).
 
theorem open_ex_t_1_imp ===
  hyp ??? nfi(x) ---> A = B
  ----------------
  (ex x:A X) => (ex x:B X).
 
theorem open_ex_t_1_iff ===
  hyp ??? nfi(x) ---> A = B
  -----------------
  (ex x:A X) <=> (ex x:B X).
	
theorem open_ex_one_t_1_fol ===
  hyp ??? nfi(x) ---> A = B
  ----------------
  (ex_one x:A X) <= (ex_one x:B X).
 
theorem open_ex_one_t_1_imp ===
  hyp ??? nfi(x) ---> A = B
  ----------------
  (ex_one x:A X) => (ex_one x:B X).
 
theorem open_ex_one_t_1_iff ===
  hyp ??? nfi(x) ---> A = B
  -----------------
  (ex_one x:A X) <=> (ex_one x:B X).
	
theorem all_intro(x:obvar) ===
   hyp ??? nfi(x) +++ [x:T] ---> B
   -----------------------
   all x:T B
    provided x not_free_in T.

theorem all_elim_c(A:thy(term),x:obvar,V:thy(term)) ===
    hyp +++ [V:T => [V/x]A] ---> C
    ------------------------------------
    Node ::: C
  provided
    x not_free_in T,
    context_search(hyp, Node, CId2, all x:T A). 

theorem all_elim_c_once(A:thy(term),x:obvar,V:thy(term)) ===
    hyp --- [CId2 ::: all x:T A] +++ [V:T => [V/x]A] ---> C
    ------------------------------------
    Node ::: C
  provided
    x not_free_in T,
    context_search(hyp, Node, CId2, all x:T A). 

theorem ex_intro(x:obvar,V:thy(term)) ===
      V:T and [V/x]A
      --------------
       ex x:T A
   provided
    x not_free_in T.

theorem ex_intro2(x:obvar,V:thy(term)) ===
      hyp +++ [V:T] ---> [V/x]A,
      V:T
      -----------------
      ex x:T A
   provided
    x not_free_in T.

theorem ex_elim_c(x:obvar) ===
   hyp --- [CId ::: ex x:T A] ??? nfi(x) +++ [x:T, A] ---> C
   ----------------------
   Node ::: C
  provided
    x not_free_in T,
    x not_free_in C,
    context_search(hyp, Node, CId, ex x:T A).
    
    
theorem all_t_iff_all ===
  (all x:T B) <=> all x (x:T => B) provided
  x not_free_in T. 

theorem ex_t_iff_ex ===
  (ex x:T B) <=> ex x (x:T and B) provided
  x not_free_in T.    

theorem all_t_true ===
  (all x:T true) <=> true.

theorem ex_t_not_imp_not_all_t ===
  (ex x:T (not A)) => not all x:T A. 

theorem not_ex_t_imp_all_t_not ===
  not (ex x:T A) => all x:T not A provided
  x not_free_in T. 

theorem or_all_t_imp_all_t_or ===
  A or (all x:T B) => all x:T (A or B) provided
  x not_free_in A.     


theorem all_t_imp_iff_imp_all_t ===
  (all x:T (A => B)) <=> (A => all x:T B) provided
  x not_free_in A, x not_free_in T.   

theorem all_t_imp_imp_all_imp_all_t ===
  (all x:T (A => B)) => ((all x:T A) => all x:T B).   

theorem ex_t_imp_imp_imp_ex_t ===
  (ex x:T (A => B)) => (A => ex x:T B) provided
  x not_free_in A.      

theorem all_t_and_iff_all_t_and_all_t ===
  (all x:T (A and B)) <=> (all x:T A) and (all x:T B). 

theorem ex_t_and_imp_ex_t_and_ex_t ===
  (ex x:T (A and B)) => (ex x:T A) and (ex x:T B).  

theorem ex_t_and_nfi_iff_ex_t_and ===
  (ex x:T (A and B)) <=> (ex x:T A) and B
    provided x not_free_in B.

theorem ex_t_nfi_and_iff_and_ex_t ===
  (ex x:T (A and B)) <=> A and (ex x:T B)
    provided x not_free_in A.

theorem not_not_all_t_imp_all_t_not_not ===
  (not not all x:T A) => all x:T not not A.  

theorem imp_imp_all_t ===
  (all x:T (A => B)) => (A => all x:T B) provided
  x not_free_in A.         

theorem imp_imp_ex_t ===
  (all x:T (A => B)) => ((ex x:T A) => B) provided
  x not_free_in B.        

theorem mk_all_t ===
  (all x:T A) <=> (X:T => [X/x]A) and all x:T A.    

theorem mk_ex_t ===
  (ex x:T A) <=> (X:T and [X/x]A) or ex x:T A.    

theorem all_t_intro ===
  (A => all x:T A) provided x not_free_in A.       

theorem ex_t_intro ===
  X:T and [X/x]A => ex x:T A.  

theorem ex_t_elim ===
  ((ex x:T A) => A) provided  x not_free_in A.  

theorem ex_t_elim1 ===
  (ex x:T true) => ((ex x:T A) <=> A) provided
  x not_free_in A.            

theorem all_t_elim ===
  (all x:T A) => (X:T => [X/x]A).  

theorem all_t_elim3 ===
  (ex x:T true) => ((all x:T A) <=> A) provided
  x not_free_in A.         

theorem all_t_imp_ex_t ===
  ((all x:T A) and (ex x:T true)) => ex x:T A.     

theorem all_t_all ===
  ((all x_0:T1 all x_1:T2 A) <=> (all x_1:T2 all x_0:T1 A)) provided
  x_0 not_free_in x_1, x_1 not_free_in x_0,
  x_0 not_free_in T1, x_1 not_free_in T1,     
  x_0 not_free_in T2, x_1 not_free_in T2.     

theorem ex_t_ex ===
  ((ex x_0:T1 ex x_1:T2 A) <=> (ex x_1:T2 ex x_0:T1 A)) provided
  x_0 not_free_in x_1, x_1 not_free_in x_0,
  x_0 not_free_in T1, x_1 not_free_in T1,     
  x_0 not_free_in T2, x_1 not_free_in T2.     

theorem ex_t_eq ===
  (A:T => ex x:T x = A) provided
  x not_free_in A.  

theorem ex_t_eq_rev ===
  (A:T => ex x:T A = x) provided
  x not_free_in A.      

theorem ex_one_t_eq ===
  (A:T => ex_one x:T x = A) provided
  x not_free_in A, x not_free_in T.     

theorem ex_one_t_eq_rev ===
  (A:T => ex_one x:T A = x) provided
  x not_free_in A, x not_free_in T.       

theorem all_imp_trans ===
  (all x:T (A => B)) and (all x:T (B => C)) =>
    all x:T (A => C).      

theorem ex_t_all_t_imp_all_t_ex_t  ===
  (ex x:T all x1:T A) => all x1:T ex x:T A provided
  x not_free_in T, x1 not_free_in T, x not_free_in x1.     

theorem ex_t_imp_all_t_imp ===
  (ex x:T A) => (B <=> (all x:T (A => B))) provided
  x not_free_in B.     

theorem subtype_imp_ex_t ===
  S subtype_of T => ((ex x:S A) => ex x:T A).
 
theorem subtype_imp_all_t ===
  (S subtype_of T => all x (x:S => x:T)) provided
  x not_free_in S, x not_free_in T.      

theorem subtype_imp_all_t1 ===
  (S subtype_of T => all x:S x:T) provided
  x not_free_in T.
 
theorem subtype_subtype ===
  (is_type(S) and is_type(T) and (all x:S x:T) =>
   S subtype_of T) provided
  x not_free_in S, x not_free_in T.        

theorem subtype_iff_all_t_imp_all_t ===
  S subtype_of T => ((all x:T A) => all x:S A) provided
  x not_free_in S, x not_free_in T.
 
                         
theorem ex_one_t_imp_ex_t ===
    (ex_one x:T A) => (ex x:T A)
      provided x not_free_in T.

theorem ex_one_t_ex_t ===
    (ex_one x:T A) <=> ex x:T A and all x2:T ([x2/x]A => x = x2)
          provided x not_free_in T, x2 not_free_in T, 
                   x not_free_in x2, x2 not_free_in A.

theorem type_and_all_t_imp_imp_imp ===
    X:T and (all x:T A => B) => ([X/x]A => [X/x]B)
       provided x not_free_in T.

%%
%% Support for Window Inference - loads
%% jpred_eq_t specific information.
%%

require_tactic_file(wi_support,jpred_eq_t).


