%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##
%%
%% Generate a gumtree tactic based on the supplied premises
%% to produce an open node whose hyp context contains appropriate
%% variants of the premises.

transform([Seq|Seqs], [Hyp|Hyps], [Tac|Tacs]) :-
    transform_seq(Seq, Hyp, Tac),
    transform1(Seqs, Hyps, [Hyp], Tacs).
transform1([], [], _, [one]).
transform1([Seq|Seqs], [Hyp|Hyps], DHs, [(delete_the_hyps(DHs);Tac)|Tacs]) :-
    transform_seq(Seq, Hyp, Tac),
    transform1(Seqs, Hyps, [Hyp|DHs], Tacs).

transform_seq(Seq, TSeq, Tac) :-
    nonvar(Seq),
    Seq = '--->'(Ante, Conc),
    !,
    transform_hyp(Ante, Conc, TSeq, Tac).
transform_seq(Seq, Seq, one).

transform_hyp(hyp, Conc, Conc, one).
transform_hyp('---'(A1, Hyps), Conc, Trans, Tac) :-
    transform_hyp(A1, Conc, Trans, Tac1),
    Tac = (delete_the_hyps(Hyps);Tac1).
transform_hyp('+++'(A1, Hyps), Conc, Trans, Tac) :-
    make_conjuncts(Hyps, Conj, ConjTac),
    transform_hyp(A1, 'jprop.=>'(Conj, Conc), Trans, Tac1),
    Tac = (Tac1;rule(imp_intro);ConjTac).
transform_hyp('???'(A1, nfi(!x)), Conc, Trans, Tac) :-
    transform_hyp(A1, !!'jpred.all' !x Conc, Trans, Tac1),
    Tac = (Tac1;rule(all_intro(!x))).

make_conjuncts([X], X, one) :- !.
make_conjuncts([H|T], Conj, Tac) :-
    make_conjuncts(T, TC, Tac1),
    Conj = 'jprop.and'(H, TC),
    Tac = (rule(and_elim_c);Tac1).
    
    
