%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: p_list.thy,v 1.5 2002/05/22 05:35:22 itp Exp $

                              %%%%%%%%%%%%%%%%%%
			      %% Prolog Lists %%
                              %%%%%%%%%%%%%%%%%%

%% This is an Ergo theory that allows the use of Prolog list notation within
%% theories (e.g. `[a,b]' and `[]').
%%

add_theory(p_list).
include_theory(stdops, share).
include_theory(jprop_eq, all).


                                %%%%%%%%%%%%%%%
				%% Functions %%
                                %%%%%%%%%%%%%%%

declare '[]'.

declare '.'(_,_).

                              %%%%%%%%%%%%%%%%%%%
			      %% Opening Rules %%
                              %%%%%%%%%%%%%%%%%%%

axiom open_cons_1_eq ===
     A = B
   -------------
    A.T = B.T.
axiom open_cons_2_eq ===
     A = B
   -------------
    H.A = H.B.


    
    
    
                                 %%%%%%%%%%%%%
				 %% Tactics %%
                                 %%%%%%%%%%%%%

require_tactic_file(as_list).

%%
%% Support for Window Inference - loads
%% p_list specific information.
%%

require_tactic_file(wi_support,p_list).



