%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: porder.thy,v 1.1 2000/10/11 21:37:14 itp Exp $

%%%%%%%%%%%%%%%%%%%%
%% Partial Orders %%
%%%%%%%%%%%%%%%%%%%%

delete_theory_and_dependents(porder).
add_theory(porder).
include_theory(stdops, share).
include_theory(jpred_eq_t,  all). 
include_theory(antisym,  all). 
include_theory(refl,  all). 
include_theory(trans,  all). 


define is_porder(Type, Rel) ===
	is_refl(Type, Rel) and is_antisym(Type, Rel) and is_trans(Type, Rel).

close_theory.

theorem porder_elim ===
    is_porder(Type, Rel)
   --------------------
    is_refl(Type, Rel) and is_antisym(Type, Rel) and is_trans(Type, Rel).

theorem porder_is_antisym ===
  is_porder(Type,POrder) =>
    is_antisym(Type,POrder).
 
theorem porder_is_refl ===
  is_porder(Type,POrder) =>
    is_refl(Type,POrder).
 
theorem porder_is_trans ===
  is_porder(Type,POrder) =>
    is_trans(Type,POrder).   


