%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: stdops.thy,v 1.8 2002/02/20 02:08:30 itp Exp $
%%
%%
%% Standard Operators for the Ergo 5 Theories
%% ==========================================
%%
%% This theory file defines the operators used in the jprop
%% theory and many of its descendents.  The operators are defined
%% here in one group to provide a convenient default for all the
%% theories and to avoid having different precedences in each theory
%% (although this is allowable, it can confuse users of the theories).
%%
%% The convention is that most theories will `share' all the operators
%% in this theory via the command: include_theory(stdops,share).

add_theory(stdops).

%% All predicates are 700 (and usually non-associative).
%% NB. :/2 is defined as nonassoc 700 global operators.
add_operator(700, nonassoc, subtype_of).
add_operator(700, nonassoc, =).

add_operator(650, rightassoc, '.').
add_operator(800, prefix,     not).
add_operator(810, rightassoc, and).
add_operator(820, rightassoc, or).
add_operator(830, rightassoc, '=>').
add_operator(830, rightassoc, '<=').
add_operator(840, rightassoc, '<=>').

%% All quantifiers are loose binding, like Z.
add_operator(900, quant, all).
add_operator(900, quant, ex).
add_operator(900, quant, ex_one).
add_operator(900, quant, w_local).
add_operator(900, quant, local).
add_operator(900, quant, s_local).

declare_object_vars(x).

%% Support for window inference.

require_global_tactic_file(tables).
require_tactic_file(wi_support, stdops).

