%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: types.thy,v 1.10 2002/05/22 05:35:23 itp Exp $
%%
%% A Simple Theory of Type Constraints
%% ===================================
%%

add_theory(types).
include_theory(stdops, share).
include_theory(jpred_eq, all).
declare _:_.

declare is_type(_).

axiom type_imp_is_type ===
    X:T => is_type(T).

%% Replacement axioms for :

axiom open_type_1_iff ===
    X = Y
  -----------
   X:T <=> Y:T.

axiom open_type_2_iff ===
    A = B
  ------------
   X:A <=> X:B.

%% Replacement axiom for is_type

axiom open_is_type_1_iff ===
    A = B
  ------------
  is_type(A) <=> is_type(B).

close_theory.


define subtype_of(T,U) ===
    is_type(T) and
    is_type(U) and
    (all x (x:T => x:U)).


%% Theorems
%% ========

theorem subtype_of_refl ===
    is_type(S)
    --------------------
    S subtype_of S.

theorem subtype_of_refl1 ===
  is_type(S) <=> S subtype_of S.

theorem subtype_of_type1 ===
  S subtype_of T and X:S => X:T.

theorem subtype_of_is_type_l ===
  S subtype_of T => is_type(T).
 
theorem subtype_of_is_type_r ===
  S subtype_of T => is_type(S).
 
theorem subtype_of_type ===
  S subtype_of T => (X:S => X:T).
 
theorem subtype_of_refl2 ===
  is_type(S) => S subtype_of S.
 
theorem subtype_of_trans ===
  S subtype_of T and T subtype_of U =>
    S subtype_of U.                     

theorem open_is_type_1_fol ===
    A = B
    --------
    is_type(A) <= is_type(B).

theorem open_is_type_1_imp ===
    A = B
    --------
    is_type(A) => is_type(B).

theorem open_type_1_fol ===
    A = B
    --------
    A:T <= B:T.

theorem open_type_1_imp ===
    A = B
    --------
    A:T => B:T.

theorem open_type_2_fol ===
    A = B
    --------
    X:A <= X:B.

theorem open_type_2_imp ===
    A = B
    --------
    X:A => X:B.


theorem open_subtype_of_1_fol ===
    A = B
    --------
    A subtype_of T <= B subtype_of T.

theorem open_subtype_of_1_imp ===
    A = B
    --------
    A subtype_of T => B subtype_of T.

theorem open_subtype_of_1_iff ===
    A = B
    --------
    A subtype_of T <=> B subtype_of T.

theorem open_subtype_of_2_fol ===
    A = B
    --------
    T subtype_of A <= T subtype_of B.

theorem open_subtype_of_2_imp ===
    A = B
    --------
    T subtype_of A => T subtype_of B.

theorem open_subtype_of_2_iff ===
    A = B
    --------
    T subtype_of A <=> T subtype_of B.


%%
%% Support for Window Inference - loads
%% types specific information.
%%

require_tactic_file(wi_support,types).



